/* Time-stamp: "buffer.c, Wednesday October 1 1997 22:7:52CDT by rjonkman@ittc.ukans.edu on pepe.ittc.ukans.edu" */

/*
 * proj : NetPipe
 * file : buffer.c
 * prog : Roel Jonkman
 * date : 29th September 1997
 * rev  : 1
 * desc : Nifty buffer alocation routine.
 * rcs  : $Id$
 *
 * This software is copyrighted see COPYRIGHTS
 *
 * $Log$
 */



/*
 * system includes
 */

#include <stdio.h>
#include <stdlib.h> 

#include "error.h"
#include "buffer.h"


void *allocateBuffer (long alignment, long offset, long bufferSize,
		      void **ptr2BufferBase){
 /* 
  * input   : alignment, offset, size and a void ptr 2 store the baseptr.
  * returns : aligned ptr to requested memory.
  * output  : ptr2Base of buffer.
  * desc    : allocates buffer and returns aligned ptr.
  */

  void *ptr2UserBuffer;
 
  if ((*ptr2BufferBase = (void*)malloc(alignment+offset+bufferSize)) == SYSTEMPTRERROR) {

	systemError ("malloc");
	return NULL;

  }

  ptr2UserBuffer = (char*)(((long)*ptr2BufferBase + (long)alignment - 1) &
						   ~((long)alignment - 1));

  ptr2UserBuffer = (char*)((long)ptr2UserBuffer + (long)offset);

  return ptr2UserBuffer;

}
