/* Time-stamp: "gendef.h, Wednesday October 1 1997 22:10:33CDT by rjonkman@ittc.ukans.edu on pepe.ittc.ukans.edu" */

/*
 * proj : NetPipe
 * file : gendef.h
 * prog : Roel Jonkman
 * date : august 9th 95
 * rev  : 2
 * desc : generic definitions, reaped from NetSpec
 * rcs  : $Id: gendef.h,v 1.1 1995/06/28 22:40:37 rjonkman Exp rjonkman $
 *
 * This software is copyrighted see COPYRIGHTS
 *
 * $Log$
 */


#ifndef GENDEF_H
#define GENDEF_H



/*
 * defines for use in movement specifications
 */

#define FORWARD  1
#define BACKWARD -1
#define STAY     0



/*
 * returncodes in for gendef compliant stuff, (< 25 == gendef)
 */

#define NOK      0
#define ERROR    0
#define OK       1
#define FOUND    1
#define NOTFOUND 2
#define INOK     3

typedef enum returnCode_t {

  Ok = 0,
  Error = 1,
  Nok = 1,
  Fail,
  Warning,
  Debug

} returnCode_t;



/*
 * defines true and false
 * the defines are obsolete, the enum should be used instead.
 */

#define TRUE     1
#define FALSE    0
#define DEFAULT  -1   /* this defines default behaviour, maybe TRUE or FALSE */

typedef enum {

  Default = -1,
  False = 0,
  True = 1

} boolean;



/*
 * defines for system error crap.
 */

#define SYSTEMERROR -1
#define SYSTEMPTRERROR (void*) -1



/*
 * defines used for operations 
 */

#define GET      1
#define SET      2

#endif
