/* Time-stamp: "ipaddress.c, Wednesday October 1 1997 22:10:57CDT by rjonkman@ittc.ukans.edu on pepe.ittc.ukans.edu" */

/*
 * proj : NetPipe
 * file : ipaddress.c
 * prog : Roel Jonkman
 * date : november 8th 1995
 * rev  : 1
 * rcs  : $Id$
 * desc : ip address resolving etc, reaped from NetSpec, ready for a rewrite.
 *
 * This software is copyrighted see COPYRIGHTS
 *
 * $Log$
 */


/*
 * defines to force 4.4BSD behaviour
 */

#define DEBUGLEVEL 4

#define _SOCKADDR_LEN

#include "ipaddress.h" /* have to avoid double inclusions. */

#include <sys/socket.h>
#include "ipaddress.h"  /* solaris sucks. */
#include <arpa/inet.h>  /* name / ip conversions */
#include <netdb.h>      /* name server information */

#include "error.h"

#ifndef INADDR_NONE
#define INADDR_NONE -1
#endif

int str2IpAddr(char *anIpName){
  /* input   : 
   * returns : 0 if any error ipaddr otherwise
   * output  : -
   * desc    : 
   */
     
  struct hostent *hostEntry;
  struct in_addr *scratch;
  int hostAddr;

  debug ("string to ip conversion", anIpName);

  if ( (hostAddr = inet_addr( anIpName )) != INADDR_NONE){

    return (ntohl(hostAddr));  

  }  

  if ((hostEntry = gethostbyname ( anIpName )) == (struct hostent*) NULL){

    error ("gethostbyname","address could not be resolved");

    return 0;

  }  
  scratch = (struct in_addr *) hostEntry->h_addr;

  return (ntohl(scratch->s_addr));
    
}



char *ipAddr2Str (int ipAddr){
  /* input   : 
   * returns : NOK if any error OK if none.
   * output  : -
   * desc    : Tries to resolve the address to a readable name,
   *           if that fails it will translate it to the dotted string.
   */

  struct hostent *aHostEntry;
  struct in_addr addr;
  
  memset ((void*)&addr, 0, sizeof (addr));

  addr.s_addr = htonl(ipAddr);

  if ((aHostEntry = gethostbyaddr ((char*)&addr.s_addr, sizeof (ipAddr),
				   AF_INET)) != NULL)
    return (aHostEntry->h_name);

  return (inet_ntoa(addr));

}



char *ipAddr2NumStr (int ipAddr){
  /* input   : 
   * returns : NOK if any error OK if none.
   * output  : -
   * desc    : Converts an ipaddress into a numeric (dotted) string
   */

  struct in_addr addr;
  
  memset ((void*)&addr, 0, sizeof (addr));

  addr.s_addr = htonl(ipAddr);

  return (inet_ntoa(addr));

}
